import map from "../map";
import find from "../find";
import filter from "../filter";
import reject from "../reject";
import castArray from "../castArray";
class ChainWrapper {
    constructor(value) {
        this.castArray = () => {
            this._chainedFunctions.push({
                operation: castArray
            });
            return this;
        };
        this.map = (func) => {
            this._chainedFunctions.push({
                operation: map,
                func
            });
            return this;
        };
        this.filter = (func) => {
            this._chainedFunctions.push({
                operation: filter,
                func
            });
            return this;
        };
        this.find = (func) => {
            this._chainedFunctions.push({
                operation: find,
                func
            });
            return this;
        };
        this.reject = (func) => {
            this._chainedFunctions.push({
                operation: reject,
                func
            });
            return this;
        };
        this.value = () => {
            let index = -1;
            const length = this._chainedFunctions.length;
            while (++index < length) {
                const chainedFunctions = this._chainedFunctions[index];
                this._value = chainedFunctions.operation(this._value, chainedFunctions.func);
            }
            return this._value;
        };
        this._value = value;
        this._chainedFunctions = [];
    }
}
function chain(value) {
    return new ChainWrapper(value);
}
export default chain;
//# sourceMappingURL=index.js.map